import asyncio
import websockets

# Crée un dictionnaire pour stocker les connexions WebSocket par adresse IP
websocket_connections = {}
master = None

async def echo(websocket, path):
    global master
    print(websocket.remote_address[0])
    client_ip = websocket.remote_address[0]
    websocket_connections[client_ip] = websocket

    async for message in websocket:
        if message.startswith('#'):
            master = client_ip
            print(f"Il y a {len(websocket_connections)}")
            responses = await asyncio.gather(*[determine_response(ws, "search 74d181ce69fa53e60fb588719cc404e1 a 9999") for ws in websocket_connections.values() if ws != websocket])
            await websocket.send("Vous êtes le maître.")
            # Traitez les réponses ici
            for response in responses:
                print(response)

async def determine_response(ws, requete):
    print(f"Sending request to {ws.remote_address[0]}")
    await ws.send(requete)
    response = await ws.recv()
    print(f"Received response from {ws.remote_address[0]}: {response}")
    return response

async def main():
    async with websockets.serve(echo, "0.0.0.0", 16699):
        await asyncio.Future()  # Gardez le serveur actif indéfiniment

asyncio.run(main())
